(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2004-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: uindex.mli,v 1.3 2014/01/10 15:28:04 fclement Exp $*)

(* The phantom type of indices. *)

type 'a t = private Unatural.t;;

external to_t : Unatural.t -> 'a t = "%identity";;
external of_t : 'a t -> Unatural.t = "%identity";;

external of_natural : Unatural.t -> 'a t = "%identity";;
external to_natural : 'a t -> Unatural.t = "%identity";;

val of_int : int -> 'a t;;
external to_int : 'a t -> int = "%identity";;

val _0_ : 'a t;;
val _1_ : 'a t;;

val succ : 'a t -> 'a t;;
val pred : 'a t -> 'a t;;
